/*
   Try this online at  https://cscircles.cemc.uwaterloo.ca/java_visualize/
*/
import java.util.Arrays;
public class TestBuildMaxHeap {
   public static void main(String[] args) {
      final int[] a = {4, 5, 1, 8, 5, 6, 2, 3};
      System.out.println(Arrays.toString(a));
      buildMaxHeap(a);
      System.out.println(Arrays.toString(a));
   }

   public static void buildMaxHeap(int[] a) {
      final int lastParent = (a.length - 2) / 2;
      for (int i = lastParent; i >= 0; --i) {
         maxHeapify(a, i, a.length);
      }
   }

   public static void maxHeapify(int a[], int root, int heapSize) {
      final int left  = 2 * root + 1; // Index of left child of root.
      final int right = 2 * root + 2; // Index of right child of root.
      int largest; // Find where the largest value is in the
                   // root node and its two child nodes.
      if (left < heapSize && a[left] > a[root]) {
         largest = left;
      } else {
         largest = root;
      }
      if (right < heapSize && a[right] > a[largest]) {
         largest = right;
      }
      if (largest != root) { // if root is not a max-heap
         swap(a, root, largest);
         maxHeapify(a, largest, heapSize);
      }
   }

   private static void swap(int[] a, int i, int j) {
      final int temp = a[i];
      a[i] = a[j];
      a[j] = temp;
   }
}
