import java.util.Arrays;
import java.util.Random;

/**
   This program measures the runtime of the optimized
   quicksort algorithm on a sequence of growing arrays.
*/
public class QuickSort_Optimized_Profile
{
   public static void main(String[] args)
   {
      final int size = 1_000_000; // starting size for the arrays
      final int iterations = 20;  // how many times to increase the array size

      System.out.println("QuickSort Optimized.");

      for (int i = 1; i <= iterations; ++i)
      {
         int[] array = new int[i*size];
         for (int j = 0; j < array.length; ++j)
         {
            array[j] = j;
         }
         long startTime = System.currentTimeMillis();
            QuickSort_Optimized.sort(array);
         long stopTime = System.currentTimeMillis();
         final long bestCase =(stopTime - startTime);

         array = QuickSort.randomIntArray(i*size, 1_000_000);
         startTime = System.currentTimeMillis();
            QuickSort_Optimized.sort(array);
         stopTime = System.currentTimeMillis();
         final long avgCase =(stopTime - startTime);

         array = new int[i*size];
         for (int j = 0; j < array.length; ++j)
         {
            array[j] = i*size - j;
         }
         startTime = System.currentTimeMillis();
            QuickSort_Optimized.sort(array);
         stopTime = System.currentTimeMillis();
         final long worstCase =(stopTime - startTime);

         System.out.println(
            "For n = " + (i*size) + ", "
          + "best time = " + bestCase + ", "
          + "avg time = " + avgCase + ", "
          + "worst time = " + worstCase);
      }
   }
}